rebase -i: abort cleanly if the editor fails to launch
[git/dscho.git] / git-sh-setup.sh
blobaa07cc3d188df9744d50d8e0487c86a2cb30b1ac
1 #!/bin/sh
3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
6 # it dies.
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be taken to unexpected places.  If you
10 # like CDPATH, define it for your interactive shell sessions without
11 # exporting it.
12 unset CDPATH
14 git_broken_path_fix () {
15         case ":$PATH:" in
16         *:$1:*) : ok ;;
17         *)
18                 PATH=$(
19                         SANE_TOOL_PATH="$1"
20                         IFS=: path= sep=
21                         set x $PATH
22                         shift
23                         for elem
24                         do
25                                 case "$SANE_TOOL_PATH:$elem" in
26                                 (?*:/bin | ?*:/usr/bin)
27                                         path="$path$sep$SANE_TOOL_PATH"
28                                         sep=:
29                                         SANE_TOOL_PATH=
30                                 esac
31                                 path="$path$sep$elem"
32                                 sep=:
33                         done
34                         echo "$path"
35                 )
36                 ;;
37         esac
40 # @@BROKEN_PATH_FIX@@
42 die() {
43         echo >&2 "$@"
44         exit 1
47 GIT_QUIET=
49 say () {
50         if test -z "$GIT_QUIET"
51         then
52                 printf '%s\n' "$*"
53         fi
56 if test -n "$OPTIONS_SPEC"; then
57         usage() {
58                 "$0" -h
59                 exit 1
60         }
62         parseopt_extra=
63         [ -n "$OPTIONS_KEEPDASHDASH" ] &&
64                 parseopt_extra="--keep-dashdash"
66         eval "$(
67                 echo "$OPTIONS_SPEC" |
68                         git rev-parse --parseopt $parseopt_extra -- "$@" ||
69                 echo exit $?
70         )"
71 else
72         dashless=$(basename "$0" | sed -e 's/-/ /')
73         usage() {
74                 die "Usage: $dashless $USAGE"
75         }
77         if [ -z "$LONG_USAGE" ]
78         then
79                 LONG_USAGE="Usage: $dashless $USAGE"
80         else
81                 LONG_USAGE="Usage: $dashless $USAGE
83 $LONG_USAGE"
84         fi
86         case "$1" in
87                 -h|--h|--he|--hel|--help)
88                 echo "$LONG_USAGE"
89                 exit
90         esac
93 set_reflog_action() {
94         if [ -z "${GIT_REFLOG_ACTION:+set}" ]
95         then
96                 GIT_REFLOG_ACTION="$*"
97                 export GIT_REFLOG_ACTION
98         fi
101 git_editor() {
102         : "${GIT_EDITOR:=$(git config core.editor)}"
103         : "${GIT_EDITOR:=${VISUAL:-${EDITOR}}}"
104         case "$GIT_EDITOR,$TERM" in
105         ,dumb)
106                 echo >&2 "No editor specified in GIT_EDITOR, core.editor, VISUAL,"
107                 echo >&2 "or EDITOR. Tried to fall back to vi but terminal is dumb."
108                 echo >&2 "Please set one of these variables to an appropriate"
109                 echo >&2 "editor or run $0 with options that will not cause an"
110                 echo >&2 "editor to be invoked (e.g., -m or -F for git-commit)."
111                 exit 1
112                 ;;
113         esac
114         eval "${GIT_EDITOR:=vi}" '"$@"'
117 sane_grep () {
118         GREP_OPTIONS= LC_ALL=C grep "$@"
121 sane_egrep () {
122         GREP_OPTIONS= LC_ALL=C egrep "$@"
125 is_bare_repository () {
126         git rev-parse --is-bare-repository
129 cd_to_toplevel () {
130         cdup=$(git rev-parse --show-cdup)
131         if test ! -z "$cdup"
132         then
133                 # The "-P" option says to follow "physical" directory
134                 # structure instead of following symbolic links.  When cdup is
135                 # "../", this means following the ".." entry in the current
136                 # directory instead textually removing a symlink path element
137                 # from the PWD shell variable.  The "-P" behavior is more
138                 # consistent with the C-style chdir used by most of Git.
139                 cd -P "$cdup" || {
140                         echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
141                         exit 1
142                 }
143         fi
146 require_work_tree () {
147         test $(git rev-parse --is-inside-work-tree) = true ||
148         die "fatal: $0 cannot be used without a working tree."
151 get_author_ident_from_commit () {
152         pick_author_script='
153         /^author /{
154                 s/'\''/'\''\\'\'\''/g
155                 h
156                 s/^author \([^<]*\) <[^>]*> .*$/\1/
157                 s/'\''/'\''\'\'\''/g
158                 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
160                 g
161                 s/^author [^<]* <\([^>]*\)> .*$/\1/
162                 s/'\''/'\''\'\'\''/g
163                 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
165                 g
166                 s/^author [^<]* <[^>]*> \(.*\)$/\1/
167                 s/'\''/'\''\'\'\''/g
168                 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
170                 q
171         }
172         '
173         encoding=$(git config i18n.commitencoding || echo UTF-8)
174         git show -s --pretty=raw --encoding="$encoding" "$1" -- |
175         LANG=C LC_ALL=C sed -ne "$pick_author_script"
178 # Make sure we are in a valid repository of a vintage we understand,
179 # if we require to be in a git repository.
180 if test -z "$NONGIT_OK"
181 then
182         GIT_DIR=$(git rev-parse --git-dir) || exit
183         if [ -z "$SUBDIRECTORY_OK" ]
184         then
185                 test -z "$(git rev-parse --show-cdup)" || {
186                         exit=$?
187                         echo >&2 "You need to run this command from the toplevel of the working tree."
188                         exit $exit
189                 }
190         fi
191         test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
192                 echo >&2 "Unable to determine absolute path of git directory"
193                 exit 1
194         }
195         : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
198 # Fix some commands on Windows
199 case $(uname -s) in
200 *MINGW*)
201         # Windows has its own (incompatible) sort and find
202         sort () {
203                 /usr/bin/sort "$@"
204         }
205         find () {
206                 /usr/bin/find "$@"
207         }
208         ;;
209 esac